序列中找子序列的dp

题目网址: http://codeforces.com/problemset/problem/414/B

Description

Mashmokh‘s boss, Bimokh, didn‘t like Mashmokh. So he fired him. Mashmokh decided to go to university and participate in ACM instead of finding a new job. He wants to become a member of Bamokh‘s team. In order to join he was given some programming tasks and one week to solve them. Mashmokh is not a very experienced programmer. Actually he is not a programmer at all. So he wasn‘t able to solve them. That‘s why he asked you to help him with these tasks. One of these tasks is the following.

A sequence of l integers b1, b2, ..., bl(1 ≤ b1 ≤ b2 ≤ ... ≤ bl ≤ n) is called good if each number divides (without a remainder) by the next number in the sequence. More formally  for all i(1 ≤ i ≤ l - 1).

Given n and k find the number of good sequences of length k. As the answer can be rather large print it modulo 1000000007(109 + 7).

Input

The first line of input contains two space-separated integers n, k (1 ≤ n, k ≤ 2000).

Output

Output a single integer — the number of good sequences of length k modulo 1000000007(109 + 7).

Sample Input

Input

3 2

Output

5

Input

6 4

Output

39

Input

2 1

Output

2

Hint

In the first sample the good sequences are: [1, 1], [2, 2], [3, 3], [1, 2], [1, 3].

#include <stdio.h>
#include <string.h>
#include <iostream>

using namespace std ;
const int N=2010;
const int mod=1e9+7;
int dp[N][N];        //dp[i][j]表示长度为i,最后一个元素为j的序列数。

int main()
{
    int n,k;
    while(cin>>n>>k)
    {
        memset(dp,0,sizeof(dp));
        for(int i=1;i<=n;i++)
        dp[1][i]=1;
        for(int t=1;t<k;t++)
        {
            for(int i=1;i<=n;i++)
            {
                for(int j=1;i*j<=n;j++)
                {
                    dp[t+1][i*j]+=dp[t][i];//从i=1循环到n,i*j即凡是i的倍数的dp值均加上上一行(序列长度少一)的dp[t][i]值。
                    dp[t+1][i*j]%=mod;
                }
            }
        }
        int set=0;
        for(int i=1;i<=n;i++)
        {
            set+=dp[k][i];
            set%=mod;
        }
        cout<<set<<endl;
    }
    return 0 ;
}
时间: 2024-10-12 13:33:31

序列中找子序列的dp的相关文章

在线性级别时间内找出无序序列中的第k个元素

在一个无序序列中找出第k个元素,对于k很小或者很大时可以采取特殊的方法,比如用堆排序来实现 .但是对于与序列长度N成正比的k来说,就不是一件容易的事了,可能最容易想到的就是先将无序序列排序再遍历即可找出第k个元素.由于任何基于比较的排序算法不可能用少于Θ(N lgN)次比较来实现将所有元素排序,所以采用排序的方法的时间复杂度是线性对数级别的. 我们可以借鉴快速排序中将序列划分的思想来实现平均情况下线性级别的算法,算法实现如下: 1 public class KthElement { 2 3 pr

算法题:找出同一个序列中的最大值和最小值

package arithmetic; /** * 同时找出一个序列中最大值和最小值 * 分两种情况:(1)序列只有两个元素 * (2)序列有多个元素,有多个元素分别从序列的两端开始查找 * @author SHI */ public class MaxAndMin { public static void main(String[] args) { int[] a = { 122, 41, 4, 5, 7, 2, 89, 122, 34, 56 }; int low = 0; int high

【python cookbook】【数据结构与算法】12.找出序列中出现次数最多的元素

问题:找出一个元素序列中出现次数最多的元素是什么 解决方案:collections模块中的Counter类正是为此类问题所设计的.它的一个非常方便的most_common()方法直接告诉你答案. # Determine the most common words in a list words = [ 'look', 'into', 'my', 'eyes', 'look', 'into', 'my', 'eyes', 'the', 'eyes', 'the', 'eyes', 'the', '

[PY3]——找出一个序列中出现次数最多的元素/collections.Counter 类的用法

问题 怎样找出一个序列中出现次数最多的元素呢? 解决方案 collections.Counter 类就是专门为这类问题而设计的, 它甚至有一个有用的 most_common() 方法直接给了你答案 collections.Counter 类 1. most_common(n)统计top_n from collections import Counter words = [ 'look', 'into', 'my', 'eyes', 'look', 'into', 'my', 'eyes', 't

算法试题 - 找出一个序列中出现频率最高的三个数

题目 找出一个序列中出现频率最高的三个数 解析 思路一 创建一个新字典, k 为 序列的值, 然后 v 的初始值 0, 然后循环序列进行计数, 然后进行新字典的处理..... 不行, 不好处理了. 此思路不行 思路二 利用 colletctions 的 Counter 模块, 内部有个方法可以解决 k 值问题 答案 答案一 可以往下继续实现, 但是有点麻烦了 li = [2, 5, 3, 4, 1, 8, 1, 2, 6, 6, 1, 5, 1, 5] d = dict.fromkeys(li,

最长上升子序列--经典dp

最长上升子序列 Time Limit: 3000ms   Memory limit: 65536K  有疑问?点这里^_^ 题目描述 一个数的序列bi,当b1 < b2 < ... < bS的时候,我们称这个序列是上升的.对于给定的一个序列(a1, a2, ..., aN),我们可以得到一些上升的子序列(ai1, ai2, ..., aiK),这里1<= i1 < i2 < ... < iK <= N.比如,对于序列(1, 7, 3, 5, 9, 4, 8)

LCS 最长公共子序列(DP经典问题)

最长公共子序列问题以及背包问题都是DP(动态规划)算法的经典题目,值得深度挖掘以致了解DP算法思想.问题如下: 最长公共子序列 时间限制:3000 ms  |  内存限制:65535 KB 难度:3 描述 咱们就不拐弯抹角了,如题,需要你做的就是写一个程序,得出最长公共子序列. tip:最长公共子序列也称作最长公共子串(不要求连续),英文缩写为LCS(Longest Common Subsequence).其定义是,一个序列 S ,如果分别是两个或多个已知序列的子序列,且是所有符合此条件序列中最

最长上升子序列(dp)

链接:https://www.nowcoder.com/questionTerminal/d83721575bd4418eae76c916483493de来源:牛客网 广场上站着一支队伍,她们是来自全国各地的扭秧歌代表队,现在有她们的身高数据,请你帮忙找出身高依次递增的子序列. 例如队伍的身高数据是(1.7.3.5.9.4.8),其中依次递增的子序列有(1.7),(1.3.5.9),(1.3.4.8)等,其中最长的长度为4. 输入描述: 输入包含多组数据,每组数据第一行包含一个正整数n(1≤n≤

序列中的交换问题

一.逆序对系列问题 题目:http://poj.org/problem?id=1804 题意:给定一个序列a[],每次只允许交换相邻两个数,最少要交换多少次才能把它变成非递降序列. 求逆序对的裸题. 如果我们交换相邻两个数,我们逆序对的个数只能是+1或-1 我们现在需要得到一个非递减数列,即消去所有逆序对, 而我们需要最少交换次数,即统计原数组中逆序对个数. 对于一个序列中,有Ai>Aj,i<j的两个元素,我们把这个二元组称为逆序对 有常见的三种方法求逆序对 1.n^2的冒泡 2.树状数组 可